var m_ObjectUrl = {
    UrlFWOA: "http://oa.fway.com.cn:81",
    UrlSystem: localStorage.getItem("UrlSystem"),
    UrlWeixin: localStorage.getItem("UrlWeixin"),
    MeanText: localStorage.getItem("MeanText"),
    UrlPic: localStorage.getItem("UrlPic")
};

// 按钮状态控制JS
if (window.location.href.indexOf("setting.html") > -1 || window.location.href.indexOf("login.html") > -1) {
    document.write('<script src="js/btn-loading.js"></script>');
} else {
    document.write('<script src="../../js/btn-loading.js"></script>');
}

// 默认图片地址
var strSrc = "../../images/smallicons/default.png";
// 部门标识和用户ID和GUID
var strBMde = localStorage.getItem("BMCode");
var strUserID = localStorage.getItem("UserID");
var strGUID = localStorage.getItem("GUID");

/**
 * [访问后台并请求数据]
 * @param  {json}     jsondata     [json格式数据]
 * @param  {function} callback     [回调函数]
 * @param  {Boolean}  async        [true：异步 false：同步]
 * @param  {object}   objBtn	   [点击button对象或者html元素对象]
 * @return {[type]}                [description]
 */
function getDataAccess(jsondata, callback, async, objBtn) {
    // 点击按钮或者页面上的html元素，改变文本样式及禁用按钮
    e_ClickAfter(objBtn);
    var bAsync = (undefined == async || null == async) ? true : async;
    mui.ajax(m_ObjectUrl.UrlSystem + '/_Beauty/NewApp/Action.ashx', {
        type: 'post',
        async: bAsync,
        data: jsondata,
        dataType: 'jsonp',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                // 判断是否返回的数据是否为空
                if ('' != result) {
                    var objJson = JSON.parse(result);
                    if ('3' == objJson.Flag[0].bFlag) {
                        mui.toast(objJson.Flag[0].Data);
                    }
                }
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
            //console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("");//回调
            }
        },
        // 调用完成事件，不管是成功或失败都会执行 
        complete: function (XMLHttpRequest, textStatus) {
            e_ClickComplete(objBtn);
        }
    });
}

//支付调用支付接口
function getPayment(jsondata, callback) {
    mui.ajax(m_ObjectUrl.UrlSystem + '/_Beauty/NewApp/PayOn.ashx', {
        type: 'post',
        data: jsondata,
        dataType: 'jsonp',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
            //console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("");//回调
            }
        }
    });
}

// 向订单表写入数据
function getOrder(jsondata, callback) {
    mui.ajax(m_ObjectUrl.UrlSystem + '/_Beauty/NewApp/NetworkPay.ashx', {
        type: 'post',
        data: jsondata,
        dataType: 'jsonp',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
            //console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("");//回调
            }
        }
    });
}

// 自动更新接口
function getEdition(jsondata, callback) {
    mui.ajax(m_ObjectUrl.UrlFWOA + '/_FWOA/App/Version.ashx', {
        type: 'post',
        data: jsondata,
        dataType: 'text',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
            console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("");//回调
            }
        },
        // 调用完成事件，不管是成功或失败都会执行
        complete: function (XMLHttpRequest, textStatus) {
        }
    });
}

// 商户授权接口
function getBusinCode(jsondata, callback, objBtn) {
    // 判断 objBtn 是否为有效数据
    if (null != objBtn && undefined != objBtn) {
        // 改变文本样式及禁用按钮
        e_ClickAfter(objBtn);
    }
    mui.ajax(m_ObjectUrl.UrlFWOA + '/_FWOA/App/Author.ashx', {
        type: 'post',
        data: jsondata,
        dataType: 'text',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
        	console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("");//回调
            }
        },
        // 调用完成事件，不管是成功或失败都会执行
        complete: function (XMLHttpRequest, textStatus) {
            e_ClickComplete(objBtn);
        }
    });
}

// FWay验证是否授权
function getFWayPrrmis(jsondata, callback) {
    mui.ajax(m_ObjectUrl.UrlFWOA + '/_FWOA/App/Prrmis.ashx', {
        type: 'post',
        async: false,
        data: jsondata,
        dataType: 'text',
        timeout: 15000,
        success: function (result) {
            // 调用回调函数
            if (callback && (callback instanceof Function)) {
                return callback(result);//回调
            }
        },
        error: function (xhr, etype, eobject) {
            console.log(etype);
            if (callback && (callback instanceof Function)) {
                return callback("ok");//回调
            }
        }
    });
}

// 判断是否返回接口地址
function e_FunDuisl() {
    // 判断接口地址是否已经返回出来了
    if ("" == m_ObjectUrl.UrlSystem || null == m_ObjectUrl.UrlSystem) {
        window.location.href = "setting.html";
    }
}

// 清理缓存
function e_ClearHC() {
    localStorage.setItem('UrlSystem', "");
    localStorage.setItem('UrlWeixin', "");
    localStorage.setItem("MeanText", "");
    window.location.href = "setting.html";
}