/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function ($, owner) {
    /**
	 * 用户登录
	 **/
    owner.login = function (loginInfo, callback, objBtn) {
        callback = callback || $.noop;
        loginInfo = loginInfo || {};
        loginInfo.account = loginInfo.account || '';
        loginInfo.password = loginInfo.password || '';
        // 判断接口地址是否已经返回出来了
        e_FunDuisl();
        if (loginInfo.account == "") {
            return callback('请输入账号');
        }
        if (loginInfo.password == "") {
            return callback('请输入密码');
        }
        var strSate = i_Authorztion(objBtn);
        // 判断是否授权
        if ('ok' != strSate) {
            return callback(strSate);
        }
        strSate = i_FwayAuthor(objBtn);
        // Fway验证是否授权
        if ('ok' != strSate) {
            return callback(strSate);
        }
        // 访问登录
        var datajson = "{\"strLoginName\":'" + loginInfo.account + "',\"strLoginPwd\":'" + loginInfo.password + "'}";
        // 点击按钮，改变文本样式及禁用按钮
        e_ClickAfter(objBtn);
        mui.ajax(m_ObjectUrl.UrlSystem + '/_Beauty/NewApp/Action.ashx', {
            async: true,//默认为true 异步
            type: 'POST',
            data: { Action: 1, strJson: datajson },
            dataType: 'jsonp',
            timeout: 20000,
            success: function (result) {
                if ("" == result) {
                    return callback('用户名或密码错误');
                } else {
                    var strJson = JSON.parse(result);
                    // 判断请求结果，0：没有数据，1：成功，2：失败
                    if ('1' == strJson.Flag[0].bFlag) {
                        // 将登陆名存入缓存
                        localStorage.setItem("LoginName", loginInfo.account);
                        localStorage.setItem('UserID', strJson.Data[0].UserID);
                        localStorage.setItem('UserName', strJson.Data[0].UserName);
                        localStorage.setItem('BMCode', strJson.Data[0].BMCode);
                        localStorage.setItem("BMName", strJson.Data[0].BMName);
                        localStorage.setItem("GUID", strJson.Data[0].GUID);
                        // 登录成功
                        return owner.createState(loginInfo.account, callback);
                    }
                    else {
                        return callback('用户名或密码错误');
                    }
                }
            },
            error: function (xhr, etype, eobject) {
                console.log(JSON.stringify(xhr) + JSON.stringify(etype) + JSON.stringify(eobject));
                return callback('网络不佳，登录超时!');
            },
            // 调用完成事件，不管是成功或失败都会执行
            complete: function (XMLHttpRequest, textStatus) {
                e_ClickComplete(objBtn);
            }
        });
    };

    owner.createState = function (name, callback) {
        var state = owner.getState();
        state.account = name;
        state.token = "token123456789";
        owner.setState(state);
        return callback();
    };



    /**
	 * 获取当前状态
	 **/
    owner.getState = function () {
        var stateText = localStorage.getItem('$state') || "{}";
        return JSON.parse(stateText);
    };

    /**
	 * 设置当前状态
	 **/
    owner.setState = function (state) {
        state = state || {};
        localStorage.setItem('$state', JSON.stringify(state));
        //var settings = owner.getSettings();
        //settings.gestures = '';
        //owner.setSettings(settings);
    };

    var checkEmail = function (email) {
        email = email || '';
        return (email.length > 3 && email.indexOf('@') > -1);
    };

    /**
	 * 找回密码
	 **/
    owner.forgetPassword = function (email, callback) {
        callback = callback || $.noop;
        if (!checkEmail(email)) {
            return callback('邮箱地址不合法');
        }
        return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
    };

    /**
	 * 获取应用本地配置
	 **/
    owner.setSettings = function (settings) {
        settings = settings || {};
        localStorage.setItem('$settings', JSON.stringify(settings));
    }

    /**
	 * 设置应用本地配置
	 **/
    owner.getSettings = function () {
        var settingsText = localStorage.getItem('$settings') || "{}";
        return JSON.parse(settingsText);
    }
    /**
     * 获取本地是否安装客户端
     **/
    owner.isInstalled = function (id) {
        if (id === 'qihoo' && mui.os.plus) {
            return true;
        }
        if (mui.os.android) {
            var main = plus.android.runtimeMainActivity();
            var packageManager = main.getPackageManager();
            var PackageManager = plus.android.importClass(packageManager)
            var packageName = {
                "qq": "com.tencent.mobileqq",
                "weixin": "com.tencent.mm",
                "sinaweibo": "com.sina.weibo"
            }
            try {
                return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
            } catch (e) { }
        } else {
            switch (id) {
                case "qq":
                    var TencentOAuth = plus.ios.import("TencentOAuth");
                    return TencentOAuth.iphoneQQInstalled();
                case "weixin":
                    var WXApi = plus.ios.import("WXApi");
                    return WXApi.isWXAppInstalled()
                case "sinaweibo":
                    var SinaAPI = plus.ios.import("WeiboSDK");
                    return SinaAPI.isWeiboAppInstalled()
                default:
                    break;
            }
        }
    }
}(mui, window.app = {}));

// 验证平板是否授权
function i_Authorztion(objBtn) {
    var strRet = "";
    var jsondata = { Action: 75, strWhere: localStorage.getItem("EqpenCode"), ID: plus.device.uuid };
    getDataAccess(jsondata, function (obj) {
        // 判断是否获取到了数据
        if ('' == obj) {
            // 结束，跳转默认页面
            strRet = '网络异常';
        } else {
            var strJson = JSON.parse(obj);
            if ('1' != strJson.Flag[0].bFlag) {
                strRet = strJson.Data[0].Prompt;
            } else {
                strRet = "ok";
            }
        }
    }, false, objBtn);
    return strRet;
}

//Fway验证平板是否授权 
function i_FwayAuthor(objBtn) {
    var strRet = "";
    var jsondata = { Mac: localStorage.getItem("EqpenCode") };
    getFWayPrrmis(jsondata, function (obj) {
        // 判断是否获取到了数据
        if ('' == obj) {
            // 结束，跳转默认页面
            strRet = '网络异常';
        } else {
            var strJson = JSON.parse(obj);
            if ('1' != strJson.Flag[0].bFlag) {
                strRet = "对不起，平板未授权!!!!";
            } else {
                strRet = "ok";
            }
        }
    }, false, objBtn);
    return strRet;
}
