﻿/**
 * [点击按钮，改变文本样式及禁用按钮]
 * @param  {object} objBtn      [点击btn的对象或者页面上的html元素对象]
 * @return {[type]}             [description]
 */
function e_ClickAfter(objBtn) {
    // 判断传过来的对象是否合法
    if (null != objBtn && undefined != objBtn) {
        // 记录样式，存储到该对象的属性上（oldClass）
        objBtn.setAttribute("oldClass", objBtn.getAttribute("class"));
        // 设置按钮为禁用
        objBtn.setAttribute("disabled", "disabled");
        // 获取按钮的类型，button、submit、其他html元素
        var strType = objBtn.getAttribute("type");
        if ("button" == strType) {
            // 记录文本值，存储到该对象的属性上（oldText）
            objBtn.setAttribute("oldText", objBtn.value);
            objBtn.value = objBtn.value + "...";
        } else if ("submit" == strType) {
            // 记录文本值，存储到该对象的属性上（oldText）
            objBtn.setAttribute("oldText", objBtn.innerText);
            objBtn.innerText = objBtn.innerText + "...";
        } else {
            // 记录文本值，存储到该对象的属性上（oldText）
            objBtn.setAttribute("oldText", objBtn.innerText);
            objBtn.innerText = objBtn.innerText + "...";
        }
        // 设置 class
        objBtn.setAttribute("class", objBtn.getAttribute("class") + " " + "btn-loading");
    }
}

/**
 * [按钮复原方法]
 * @param  {object} objBtn      [点击btn的对象或者页面上的html元素对象]
 * @return {[type]}             [description]
 */
function e_ClickComplete(objBtn) {
    // 存储当前点击的对象html元素类型
    var strType = "";
    if (null != objBtn && undefined != objBtn) {
        // 获取元素类型
        strType = objBtn.getAttribute("type");
        if ("button" == strType) {
            // 设置文本
            objBtn.value = objBtn.getAttribute("oldText");
        } else if ("submit" == strType) {
            objBtn.innerText = objBtn.getAttribute("oldText");
        } else {
            objBtn.innerText = objBtn.getAttribute("oldText");
        }
        // 设置样式
        objBtn.setAttribute("class", objBtn.getAttribute("oldClass"));
        // 移除禁用样式
        objBtn.removeAttribute("disabled");
        // 移除存储的文本
        objBtn.removeAttribute("oldText");
        // 移除存储的类样式
        objBtn.removeAttribute("oldClass");
    }
}